local Lib = MissionMinder
Lib.callbacks = Lib.callbacks or LibStub("CallbackHandler-1.0"):New(Lib)

local OPTIONS = Lib.options;
local DEBUG = Lib.debug;
local module = Lib.multiplanner

local L = LibStub("AceLocale-3.0"):GetLocale("MissionMinder");

local PLANNER = {}
module.PLANNER = PLANNER

print("PlannerState.lua");

function PLANNER:New()
	local self = {
		["name"] = "PLANNER"
	}

	function self:initialize()
		local activeFollowers = C_Garrison.GetNumActiveFollowers()
		local maxFollowers = C_Garrison.GetFollowerSoftCap()

		local availableFollowers = 1
		local smallestFollowerRequirement = 0
		if ( numMissions == 0 ) then
			module.showStatusOverlay(GARRISON_EMPTY_MISSION_LIST);
		elseif ( activeFollowers > maxFollowers ) then
			module.showStatusOverlay(GARRISON_PLANNER_TOO_MANY_ACTIVE_FOLLOWERS);
		elseif ( availableFollowers < smallestFollowerRequirement ) then
			module.showStatusOverlay(GARRISON_PLANNER_NOT_ENOUGH_FOLLOWERS_FOR_CURRENT_MISSIONS);
		else
			module.hideStatusOverlay()
		end

		-- Update mission list
		PlannerMissionList_Update()

		module.updateReadyMissionCount()
	end

	function self:destroy()
	end

	function self:updateMissions()
		local plannerTab = GarrisonMissionFrame.PlannerTab;
		local missions = C_Garrison.GetAvailableMissions();
		Garrison_SortMissions(missions);
		local numMissions = #missions;

		local scrollFrame = plannerTab.listScroll;
		local offset = HybridScrollFrame_GetOffset(scrollFrame);
		local buttons = scrollFrame.buttons;
		local numButtons = #buttons;

		for i = 1, numButtons do
			local button = buttons[i];
			local index = offset + i;

			module.setMissionButton(button, missions, index)
			module.markForUpdate(button)
			if ( GarrisonMissionFrame.PlannerTab.Overlay:IsShown() ) then
				button:Disable();
			else
				button:Enable();
			end
		end

		local totalHeight = numMissions * scrollFrame.buttonHeight;
		local displayedHeight = numButtons * scrollFrame.buttonHeight;
		HybridScrollFrame_Update(scrollFrame, totalHeight, displayedHeight);
	end

	function self:buttonEnter()
	end

	function self:buttonClick()
	end

	function self:buttonDoubleClick()
	end

	return self
end
